using System;
using System.Runtime.InteropServices;

/// <summary>
/// MAI-2088 API library definitions
/// </summary>
public class MAI2088
{
    // Device status (Return codes)
    public const int MAI2088_OK = 0;
    public const int MAI2088_INVALID_HANDLE = 1;
    public const int MAI2088_DEVICE_NOT_FOUND = 2;
    public const int MAI2088_DEVICE_NOT_OPENED = 3;
    public const int MAI2088_OTHER_ERROR = 4;
    public const int MAI2088_COMMUNICATION_ERROR = 5;
    public const int MAI2088_OUT_OF_RANGE_PARAMETER = 6;

    // Constants
    public const int MAI2088_LOW = 0;
    public const int MAI2088_HIGH =	1;
    public const int MAI2088_OFF = 0;
    public const int MAI2088_ON = 1;
    public const int MAI2088_ENCODER_SENSITIVITY_LEVEL1 = 0;
    public const int MAI2088_ENCODER_SENSITIVITY_LEVEL2 = 1;
    public const int MAI2088_ENCODER_SENSITIVITY_LEVEL3 = 2;
    public const int MAI2088_ENCODER_SENSITIVITY_LEVEL4 = 3;
    public const int MAI2088_ENCODER_SENSITIVITY_LEVEL5 = 4;
    public const int MAI2088_ENCODER_SENSITIVITY_LEVEL6 = 5;
    public const int MAI2088_ENCODER_SENSITIVITY_LEVEL7 = 6;
    public const int MAI2088_ENCODER_SENSITIVITY_LEVEL8 = 7;

    // Function definitions
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_getNumberOfDevices (ref int number);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_getSerialNumber (int index, ref int serialNumber);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_open (ref System.IntPtr handle);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_openBySerialNumber (int serialNumber, ref System.IntPtr handle);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_close (System.IntPtr handle);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_initialize (System.IntPtr handle);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_getVersion (System.IntPtr handle, ref int version);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_getAnalogInputValue (System.IntPtr handle, int index, ref int value);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_getDigitalInputState (System.IntPtr handle, int index, ref int state);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_getDigitalOutputState (System.IntPtr handle, int index, ref int state);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_setDigitalOutputState (System.IntPtr handle, int index, int state);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_getPotentiometerValue (System.IntPtr handle, int index, ref int value);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_setEncoderSensitivity (System.IntPtr handle, int index, int level);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_getEncoderPulse (System.IntPtr handle, int index, ref int pulseCount);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_getSwitchState (System.IntPtr handle, int index, ref int state);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_setLEDState (System.IntPtr handle, int index, int state);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_setLEDBrightness (System.IntPtr handle, int index, int brightness);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_setLEDBlink (System.IntPtr handle, int index, double frequency, int dutyCycle, int blinkCount);
    [DllImport("MAI2088.dll")]
    public static extern int MAI2088_set7SegmentLED (System.IntPtr handle, int activeType, char displayCharactor, int dotPoint);
}
