Attribute VB_Name = "MAI2088"
Option Explicit

' Device status (Return codes)
Public Const MAI2088_OK As Long = 0
Public Const MAI2088_INVALID_HANDLE As Long = 1
Public Const MAI2088_DEVICE_NOT_FOUND As Long = 2
Public Const MAI2088_DEVICE_NOT_OPENED As Long = 3
Public Const MAI2088_OTHER_ERROR As Long = 4
Public Const MAI2088_COMMUNICATION_ERROR As Long = 5
Public Const MAI2088_OUT_OF_RANGE_PARAMETER As Long = 6

' Constants
Public Const MAI2088_LOW As Long = 0
Public Const MAI2088_HIGH As Long = 1
Public Const MAI2088_OFF As Long = 0
Public Const MAI2088_ON As Long = 1
Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL1 As Long = 0
Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL2 As Long = 1
Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL3 As Long = 2
Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL4 As Long = 3
Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL5 As Long = 4
Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL6 As Long = 5
Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL7 As Long = 6
Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL8 As Long = 7

' Function definitions
Public Declare Function MAI2088_getNumberOfDevices Lib "MAI2088.dll" (ByRef number As Long) As Long
Public Declare Function MAI2088_getSerialNumber Lib "MAI2088.dll" (ByVal Index As Long, ByRef serialNumber As Long) As Long
Public Declare Function MAI2088_open Lib "MAI2088.dll" (ByRef handle As Long) As Long
Public Declare Function MAI2088_openBySerialNumber Lib "MAI2088.dll" (ByVal serialNumber As Long, ByRef handle As Long) As Long
Public Declare Function MAI2088_close Lib "MAI2088.dll" (ByVal handle As Long) As Long
Public Declare Function MAI2088_initialize Lib "MAI2088.dll" (ByVal handle As Long) As Long
Public Declare Function MAI2088_getVersion Lib "MAI2088.dll" (ByVal handle As Long, ByRef version As Long) As Long
Public Declare Function MAI2088_getAnalogInputValue Lib "MAI2088.dll" (ByVal handle As Long, ByVal Index As Long, ByRef value As Long) As Long
Public Declare Function MAI2088_getDigitalInputState Lib "MAI2088.dll" (ByVal handle As Long, ByVal Index As Long, ByRef state As Long) As Long
Public Declare Function MAI2088_getDigitalOutputState Lib "MAI2088.dll" (ByVal handle As Long, ByVal Index As Long, ByRef state As Long) As Long
Public Declare Function MAI2088_setDigitalOutputState Lib "MAI2088.dll" (ByVal handle As Long, ByVal Index As Long, ByVal state As Long) As Long
Public Declare Function MAI2088_getPotentiometerValue Lib "MAI2088.dll" (ByVal handle As Long, ByVal Index As Long, ByRef value As Long) As Long
Public Declare Function MAI2088_setEncoderSensitivity Lib "MAI2088.dll" (ByVal handle As Long, ByVal Index As Long, ByVal level As Long) As Long
Public Declare Function MAI2088_getEncoderPulse Lib "MAI2088.dll" (ByVal handle As Long, ByVal Index As Long, ByRef pulseCount As Long) As Long
Public Declare Function MAI2088_getSwitchState Lib "MAI2088.dll" (ByVal handle As Long, ByVal Index As Long, ByRef state As Long) As Long
Public Declare Function MAI2088_setLEDState Lib "MAI2088.dll" (ByVal handle As Long, ByVal Index As Long, ByVal state As Long) As Long
Public Declare Function MAI2088_setLEDBrightness Lib "MAI2088.dll" (ByVal handle As Long, ByVal Index As Long, ByVal brightness As Long) As Long
Public Declare Function MAI2088_setLEDBlink Lib "MAI2088.dll" (ByVal handle As Long, ByVal Index As Long, ByVal frequency As Double, ByVal dutyCycle As Long, ByVal blinkCount As Long) As Long
Public Declare Function MAI2088_set7SegmentLED Lib "MAI2088.dll" (ByVal handle As Long, ByVal activeType As Long, ByVal displayCharactor As Byte, ByVal dotPoint As Long) As Long
